//+------------------------------------------------------------------+
//|                                                $DEfectivnost.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
//     .      
//   .        .
//     ,      
//          .
//     0       
//   .
//     0       
//   .
//---- input parameters
extern int     Sredn=10;
extern int     Slow=5 ;
extern int     Ugol=2;
extern int     Dep=2 ;
extern double  StdDev=2;
//extern int       TakeProfit=20;
//extern int       StopLoss=20;
extern int     OpenPosition=5;
int            Mg=111 ;
extern double  Lots=0.1 ;
//======================================================================
int init()
  {
   return(0);
  }
//=======================================================================
int deinit()
  {
   return(0);
  }
//======================================================================
int start()
  {
   double UgolFist,UgolOld,DepFirst,DepOld ;
   UgolFist=Ugol_Linear_Regression(0,Sredn);
   UgolOld=Ugol_Linear_Regression(1,Sredn);
   DepFirst=LinearRegression3(0,Sredn) ; 
   DepOld=LinearRegression3(0,Sredn+Slow) ;
   //Print("UgolFist=",UgolFist," UgolOld=",UgolOld," DepFirst=",DepFirst," DepOld=",DepOld) ;
   if ( UgolFist > Ugol*Point && DepFirst < Dep*Point ) 
      {
         Open_Long_Position (DepFirst);
      }
   if ( UgolFist < -Ugol*Point && DepFirst < Dep*Point)  
      {
         Open_Short_Position (DepFirst);
      }
   if (  DepFirst < Ugol*Point  && UgolFist > -Ugol*Point) Close_All_Position() ;
   return(0);
  }
//========================================================================
int ChPos(int type_H_L,int Magic) 
{
   int i;
   int col;
   int count=0 ;
   for( i=0; i<=OrdersTotal(); i++)         
   {
      if(OrderSelect(i,SELECT_BY_POS)==true) 
       {                                   
           if(OrderType()==OP_BUY && OrderSymbol()==Symbol() 
              && type_H_L==1 && OrderMagicNumber()==Magic){count++;}
           if(OrderType()==OP_SELL && OrderSymbol()==Symbol() 
              && type_H_L==0 && OrderMagicNumber()==Magic){count++;}
       }
    }   
return(count);
}
//======================================================================
void Open_Short_Position (double aaa)
   {
      double TP,SL ;
      TP=Bid-aaa ;
      SL=Bid+aaa ;
      if (ChPos(0,Mg) < OpenPosition ) 
         OrderSend(Symbol(),OP_SELL,Lots,Bid,10,SL,TP,0,Mg,0,Blue);
     return(0) ;
   }
//===============================================================================
void Open_Long_Position ( double aaa)
   {
      double TP,SL ;
      TP=Ask+aaa ;
      SL=Ask-aaa ;
      if (ChPos(1,Mg) < OpenPosition ) 
         OrderSend(Symbol(),OP_BUY,Lots,Ask,10,SL,TP,0,Mg,0,Red);
    return(0) ;
   }
//==============================================================================
void Close_All_Position()
   {
      int Col_Orders=OrdersTotal(),ticket ;
      double   Lots;
      for (int i=0 ;i<=Col_Orders ; i++)
         {
            if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
               {
                     if(OrderMagicNumber()==Mg || OrderMagicNumber()==Mg) //  
                      { 
                        ticket=OrderTicket();
                        Lots=OrderLots();
                        OrderClose(ticket,Lots,Close[0],500,CLR_NONE);
                      }  
               }
         }
         return(0) ;
   }
//==============================================================================
double Ugol_Linear_Regression( int i,int N)
   {  
   int    j,counted_bars=IndicatorCounted();
   double   a,b,Summ_x,Summ_y,Summ_x_2,Summ_xy;
   if (Bars < N+1) return(0);
   for (int x=1;x<N;x++)
   {  j=N-x+i;  
      Summ_x=Summ_x+x;  
      Summ_y=Summ_y+Close[j];   
      Summ_xy=Summ_xy+x*Close[j]; 
      Summ_x_2=Summ_x_2+MathPow(x,2); 
   }
      b=((N-1)*Summ_xy-Summ_x*Summ_y)/((N-1)*Summ_x_2-MathPow(Summ_x,2));  
   return(b);
  }
//================================================================================
double   LinearRegression3 (int i, int N)
{
//          
//         
   double   Pi=3.141592653589793 ;
   int    j;
   double   a,b,Summ_x,Summ_y,Summ_x_2,Summ_xy,Deviation,StdDeviation,Sredn_y,AC;
   for (int x=1;x<N;x++)
   {  j=N-x+i;  
      Summ_x=Summ_x+x;  
      Summ_y=Summ_y+Close[j];   
      Summ_xy=Summ_xy+x*Close[j]; 
      Summ_x_2=Summ_x_2+MathPow(x,2); 
   }
      b=((N-1)*Summ_xy-Summ_x*Summ_y)/((N-1)*Summ_x_2-MathPow(Summ_x,2));  
      a=(Summ_y-b*Summ_x)/(N-1);
      Sredn_y=Summ_y/(N-1);
   for (  x=N ;x>=1 ;x--) 
      {
         j=N-x+i ;
         if ( b >0 )
            {
               AC= MathAbs(Close[j]-(b*x+a))*MathSin(Pi/2-MathArctan(b)) ;
            }
          if ( b<0 )
            {
               AC=MathAbs(Close[j]-(b*x+a))*MathSin(MathArctan(b)-Pi/2) ;
            }
        Deviation=Deviation+ MathPow(AC,2) ;  
      }
      StdDeviation=MathSqrt(Deviation/N);
   return(StdDeviation*StdDev);
  }